' TPSm8_5.bas
'----------------------------------------------------
'Tasten-programmierbare Steuerung TPS
' ATmega8, intern 8 MHz, 2 ADC, 2 PWM
'----------------------------------------------------
' vgl. dazu auf den Seiten von Burkhard Kainka
' www.elektronik-labor, unter Projekte
' den Beitrag Mini-TPS mit ATmega8
' An den gekennzeichneten Stellen wurden in den
' ursprnglichen Quelltext weitere Befehle eingefgt.
' An allen Stellen wurde Adr jeweils durch Adrs ersetzt.
' Hermann Nieder
' 11.04.2012

$regfile = "m8def.dat"
$crystal = 8000000
$hwstack = 32
$swstack = 64
$framesize = 64

'Adr gendert in Adrs
Dim Adrs As Byte
Dim Eebyte As Byte
Dim Dat As Byte
Dim Kom As Byte
Dim Adrhi As Byte
Dim Adrlo As Byte
Dim Adrret As Byte
Dim Prog As Byte
Dim Dd As Word

Dim A As Byte
Dim B As Byte
Dim C As Byte
Dim D As Byte

'2 Zeilen neu
'Dim Dat_hi As Byte
'Dim Dat_lo As Byte


'Zeile neu
Open "comb.0:9600,8,n,1" For Output As #1
'notwendig zur Ausgabe von  1 und darauf Adressenbyte
'bzw. 2 und danach Datenbyte(Befehl und Datenwert)
'an Pin PORTB.0, damit Anzeige von Adressen- und Datenbyte
'im HEX-Format z. B. auf LED-Display der Ping-Pong-Platine
'mglich

Ddrd = &H0F                                                 'D0...D1 Outputs
Portd = &HF0                                                'Pullup D4...D7
Portc = &H0F                                                'C0..C3 Inputs mit Pullup

S1 Alias Pind.6                                             'Dateneingabe
S2 Alias Pind.7                                             'Programmieren

Config Adc = Single , Prescaler = Auto , Reference = Off
Start Adc
Config Timer1 = Pwm , Prescale = 8 , Pwm = 8 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down
Start Timer1

Waitms 200

'Test: Zhlschleife
'Dat = &H45 : Writeeeprom Dat , 0                            'A=5
'Dat = &H52 : Writeeeprom Dat , 1                            'C=A
'Dat = &H11 : Writeeeprom Dat , 2                            'Por=1
'Dat = &H27 : Writeeeprom Dat , 3                            '200 ms
'Dat = &H10 : Writeeeprom Dat , 4                            'Port=0
'Dat = &H27 : Writeeeprom Dat , 5                            '200 ms
'Dat = &HA2 : Writeeeprom Dat , 6                            'C-mal jmp 2
'Dat = &H30 : Writeeeprom Dat , 7                            'Ende


'Test: Unterprogramm
'Dat = &H4F : Writeeeprom Dat , 0                            'A=15
'Dat = &H52 : Writeeeprom Dat , 1                            'C=A
'Dat = &H82 : Writeeeprom Dat , 2                            'Adr 32...
'Dat = &HD0 : Writeeeprom Dat , 3                            'Call 32+0
'Dat = &H80 : Writeeeprom Dat , 4                            'Adr 00...
'Dat = &HA2 : Writeeeprom Dat , 5                            'C-mal jmp 2
'Dat = &H30 : Writeeeprom Dat , 6                            'Ende
'Unterprogramm ab Adresse 32
'Dat = &H11 : Writeeeprom Dat , 32                           'Port=1
'Dat = &H27 : Writeeeprom Dat , 33                           '200 ms
'Dat = &H10 : Writeeeprom Dat , 34                           'Port=0
'Dat = &H27 : Writeeeprom Dat , 35                           '200 ms
'Dat = &H27 : Writeeeprom Dat , 35                           '200 ms
'Dat = &HE0 : Writeeeprom Dat , 36                           'Return


'Test: Verzweigung, Blinken wenn ADC < 7
'Dat = &H47 : Writeeeprom Dat , 0                            'A=7
'Dat = &H51 : Writeeeprom Dat , 1                            'B=A
'Dat = &H69 : Writeeeprom Dat , 2                            'A=ADC
'Dat = &H82 : Writeeeprom Dat , 3                            'Adr 32...
'Dat = &HC2 : Writeeeprom Dat , 4                            'if A<B then Adr=Adr+1
'Dat = &HD0 : Writeeeprom Dat , 5                            'Call 32+0
'Dat = &H80 : Writeeeprom Dat , 6                            'Adr 00...
'Dat = &H90 : Writeeeprom Dat , 7                            'Jump 00
'Unterprogramm ab Adresse 32
'Dat = &H11 : Writeeeprom Dat , 32                           'Port=1
'Dat = &H27 : Writeeeprom Dat , 33                           '200 ms
'Dat = &H10 : Writeeeprom Dat , 34                           'Port=0
'Dat = &H27 : Writeeeprom Dat , 35                           '200 ms
'Dat = &H27 : Writeeeprom Dat , 35                           '200 ms
'Dat = &HE0 : Writeeeprom Dat , 36                           'Return

'Test : Tastenabfrage S1
'Dat = &HCC : Writeeeprom Dat , 0                            'if S1 = 1 then Adr = Adr + 1
'Dat = &H71 : Writeeeprom Dat , 1                            'A = A + 1
'Dat = &H54 : Writeeeprom Dat , 2                            'Dout =A
'Dat = &H33 : Writeeeprom Dat , 3                            'Adr = Adr - 3


Waitms 200

If S2 = 0 Then
  Goto Programmieren
Else
Ausfuehren:
  Adrs = 0
  Do
    Readeeprom Eebyte , Adrs
    Adrs = Adrs + 1
    Dat = Eebyte And 15
    Kom = Eebyte / 16
    If Kom = 1 Then                                         '1: Direkte Portausgabe
      Portd = Dat Or &HF0
    End If
    If Kom = 2 Then                                         '2: Wartezeit
      If Dat = 0 Then Waitms 1
      If Dat = 1 Then Waitms 2
      If Dat = 2 Then Waitms 5
      If Dat = 3 Then Waitms 10
      If Dat = 4 Then Waitms 20
      If Dat = 5 Then Waitms 50
      If Dat = 6 Then Waitms 100
      If Dat = 7 Then Waitms 200
      If Dat = 8 Then Waitms 500
      If Dat = 9 Then Waitms 1000
      If Dat = 10 Then Waitms 2000
      If Dat = 11 Then Waitms 5000
      If Dat = 12 Then Waitms 10000
      If Dat = 13 Then Waitms 20000
      If Dat = 14 Then Waitms 30000
      If Dat = 15 Then Waitms 60000
    End If
    If Kom = 3 Then                                         '3: Sprung - relativ
      Adrs = Adrs - 1
      Adrs = Adrs - Dat
    End If
    If Kom = 4 Then
      A = Dat
    End If
    If Kom = 5 Then
      If Dat = 1 Then B = A                                 'Variablen
      If Dat = 2 Then C = A
      If Dat = 3 Then D = A
      If Dat = 4 Then Portd = A Or &HF0                     'Port
      If Dat = 5 Then
         If A.0 = 0 Then Portd.0 = 0 Else Portd.0 = 1       'Portbits
      End If
      If Dat = 6 Then
         If A.0 = 0 Then Portd.1 = 0 Else Portd.1 = 1
      End If
      If Dat = 7 Then
         If A.0 = 0 Then Portd.2 = 0 Else Portd.2 = 1
      End If
      If Dat = 8 Then
         If A.0 = 0 Then Portd.3 = 0 Else Portd.3 = 1
      End If
      If Dat = 9 Then
        Dd = A * 17                                         'PWM
        Pwm1a = Dd                                          'PWM
      End If
      '4 Zeilen neu
      If Dat = 10 Then
      Dd = A * 17
      Pwm1b = Dd
      End If
      '**

    End If
    If Kom = 6 Then
      If Dat = 1 Then A = B                                 'Variablen
      If Dat = 2 Then A = C
      If Dat = 3 Then A = D
      If Dat = 4 Then A = Pinb                              'Port
      If Dat = 5 Then A = Portb.0                           'Portbits
      If Dat = 6 Then A = Portb.1
      If Dat = 7 Then A = Portb.2
      If Dat = 8 Then A = Portb.3
      If Dat = 9 Then
        Dd = Getadc(4)                                      'ADC
        Dd = Dd / 64
        A = Dd
      End If
      If Dat = 10 Then
        Dd = Getadc(5)                                      'ADC
        Dd = Dd / 64
        A = Dd
      End If
    End If
    If Kom = 7 Then
      If Dat = 1 Then A = A + 1
      If Dat = 2 Then A = A - 1
      If Dat = 3 Then A = A + B
      If Dat = 4 Then A = A - B
      If Dat = 5 Then A = A * B
      If Dat = 6 Then A = A / B
      If Dat = 7 Then A = A And B
      If Dat = 8 Then A = A Or B
      If Dat = 9 Then A = A Xor B
      If Dat = 10 Then A = Not A
      A = A And 15
    End If
    If Kom = 8 Then
      Adrhi = Dat                                           'Oberes Nibble der Adresse
    End If
    If Kom = 9 Then
      Adrs = Adrhi * 16                                     'Springe absolut  0...255
      Adrs = Adrs + Dat
    End If
    If Kom = 10 Then
      C = C - 1
      C = C And 15
      If C > 0 Then                                         'C-mal
        Adrs = Adrhi * 16                                   'Springe absolut  0...255
        Adrs = Adrs + Dat
      End If

    End If
    If Kom = 11 Then
      D = D - 1
      D = D And 15
      If D > 0 Then                                         'D-mal
        Adrs = Adrhi * 16                                   'Springe absolut  0...255
        Adrs = Adrs + Dat
      End If

    End If
    If Kom = 12 Then
      If Dat = 1 Then
        If A > B Then Adrs = Adrs + 1
      End If
      If Dat = 2 Then
        If A < B Then Adrs = Adrs + 1
      End If
      If Dat = 3 Then
        If A = B Then Adrs = Adrs + 1
      End If
      If Dat = 4 Then
        If Pinc.0 = 1 Then Adrs = Adrs + 1
      End If
      If Dat = 5 Then
        If Pinc.1 = 1 Then Adrs = Adrs + 1
      End If
      If Dat = 6 Then
        If Pinc.2 = 1 Then Adrs = Adrs + 1
      End If
      If Dat = 7 Then
        If Pinc.3 = 1 Then Adrs = Adrs + 1
      End If
      If Dat = 8 Then
        If Pinc.0 = 0 Then Adrs = Adrs + 1
      End If
      If Dat = 9 Then
        If Pinc.1 = 0 Then Adrs = Adrs + 1
      End If
      If Dat = 10 Then
        If Pinc.2 = 0 Then Adrs = Adrs + 1
      End If
      If Dat = 11 Then
        If Pinc.3 = 0 Then Adrs = Adrs + 1
      End If
      If Dat = 12 Then
        If Pind.6 = 1 Then Adrs = Adrs + 1
      End If
      If Dat = 13 Then
        If Pind.7 = 1 Then Adrs = Adrs + 1
      End If
      If Dat = 14 Then
        If Pind.6 = 0 Then Adrs = Adrs + 1
      End If
      If Dat = 15 Then
        If Pind.7 = 0 Then Adrs = Adrs + 1
      End If

    End If
    If Kom = 13 Then
      Adrret = Adrs
      Adrs = Adrhi * 16                                     'Call Unterprogramm absolut  0...255
      Adrs = Adrs + Dat
    End If
    If Kom = 14 Then
      Adrs = Adrret                                         'Return
    End If
  Loop
End If


Programmieren:
  Adrs = 0
  Prog = 0
  Do
    Adrlo = Adrs And 15                                     'Adresse anzeigen
    Portd = Adrs Or &HF0
    Waitms 300
    Portd = 0 Or &HF0
    '3 neue Zeilen
    Put #1 , 1
    Waitms 5
    Put #1 , Adrs
    Waitms 200
    Readeeprom Eebyte , Adrs
    '4 neue Zeilen
    Put #1 , 2
    Waitms 5
    Put #1 , Eebyte
    Waitms 5
    Dat = Eebyte And 15
    Kom = Eebyte / 16
    Portd = Kom Or &HF0                                     'Befehl anzeigen
    Do
    Loop Until S2 = 1
    Waitms 50

    Prog = 1                                                'Phase 1: Befehl anzeigen
    Do
      If S1 = 0 Then

        If Prog = 1 Then
          Prog = 2
          Kom = 15
        End If
        If Prog = 2 Then                                    'Phase 2: Befehl verndert
          Kom = Kom + 1
          Kom = Kom And 15
          Portd = Kom Or &HF0
        End If
        If Prog = 3 Then :                                  'Phase 3: Befehl unverndert, Daten ndern
          Prog = 5
          Dat = 15
        End If
        If Prog = 4 Then                                    'Phase 4: Befehl und Daten gendert
          Prog = 5
          Dat = 15
        End If
        If Prog = 5 Then                                    'Phase 5: Daten verndert
          Dat = Dat + 1
          Dat = Dat And 15
          Portd = Dat Or &HF0
        End If
        Waitms 50
        Do
        Loop Until S1 = 1
        Waitms 50
      End If

      If S2 = 0 Then
        If Prog = 3 Then Prog = 7                           'nur angezeigt, nicht verndert
        If Prog = 1 Then
          Portd = Dat Or &HF0
          Prog = 3
        End If
        If Prog = 4 Then
          Portd = 255 - Dat
          Prog = 6
        End If
        If Prog = 2 Then
          Portd = Dat Or &HF0
          Prog = 4
        End If
        If Prog = 6 Then                                    'nur Kommando wurde verndert
          Dat = Dat And 15
          Eebyte = Kom * 16
          Eebyte = Eebyte + Dat
          Writeeeprom Eebyte , Adrs
          '2 neue Zeilen
          Put #1 , Eebyte
          Waitms 5

          Portd = 255 - 0
          Waitms 600
          Adrs = Adrs + 1
          Prog = 0
        End If
        If Prog = 5 Then                                    'Daten wurden verndert
          Dat = Dat And 15
          Eebyte = Kom * 16
          Eebyte = Eebyte + Dat
          Writeeeprom Eebyte , Adrs
          '2 neue Zeilen
          Put #1 , Eebyte
          Waitms 5
          Portd = 0 Or &HF0
          Waitms 600
          Adrs = Adrs + 1
          Prog = 0
        End If
        If Prog = 7 Then
          Adrs = Adrs + 1
          Prog = 0
        End If
        Waitms 50
        Do
        Loop Until S2 = 1
        Waitms 50
      End If
    Loop Until Prog = 0
  Loop

End